#include <FFel.hpp>
#include "gtest/gtest.h"

using FF = FFel<9>;

TEST (FFelTestsNonPrime, Plus){
    FF one = FF(1);
    FF three = FF(3);
    EXPECT_EQ (one + one + one, three);
}

TEST (FFelTestsNonPrime, Minus){
    FF one = FF(1);
    FF two = FF(2);
    FF four = FF(4);
    FF minusFive = FF(-5);
    EXPECT_EQ(one - two - four, minusFive);
}

TEST (FFelTestsNonPrime, ElementsReady){
    EXPECT_NE(FF::all()[2], FF(0));
}

TEST (FFelTestsNonPrime, PlusTimes) {
    FF alpha = FF::all()[2];
    EXPECT_EQ(alpha*(alpha+1), alpha*alpha+alpha);
}
