#include <InvolSet.hpp>
#include <ColouredPlane.hpp>
#include "gtest/gtest.h"

TEST (PointSetNautyTests, SameCanonicalForm) {
    ASSERT_EQ(V,7) << "These tests should be run with pg22.h included in options.h";
    
    PointSet set1;
    set1.add(0);
    set1.add(1);
    set1.add(2);
    
    PointSet set2;
    set2.add(5);
    set2.add( 6);
    set2.add (2);

    SparseGraph *can1 = ColouredPlane(set1).canonicalForm();
    SparseGraph *can2 = ColouredPlane(set2).canonicalForm();

    EXPECT_TRUE(aresame_sg(can1, can2)) << "Two triangles should have the same canonical form";

    delete can2;
    delete can1;
}

TEST (PointSetNautyTests, DifferentCanonicalForm) {
    ASSERT_EQ(V,7) << "These tests should be run with pg22.h included in options.h";

    PointSet set1;
    set1.add(0);
    set1.add(1);
    set1.add(2);

    PointSet set2;
    set2.add(5);
    set2.add( 6);
    set2.add( 1);

    SparseGraph *can1 = ColouredPlane(set1).canonicalForm();
    SparseGraph *can2 = ColouredPlane(set2).canonicalForm();

    EXPECT_FALSE(aresame_sg(can1, can2)) << "Triangle and line should have different canonical forms";

    delete can2;
    delete can1;
}
