#ifndef BSETS_INVOL_INVOL_HPP
#define BSETS_INVOL_INVOL_HPP

// Defines the parameters of an involution geometry in terms of the field order Q

template <int Q>
struct Invol {

    // Number of 'fat' points, i.e., involution orbits of size 2
    static constexpr int F = (Q*Q-1)/2;

    // Number of points at infinity
    static constexpr int K = Q+1;

    // Total number of orbits
    static constexpr int V = K+F+1;

};


#endif //BSETS_INVOL_INVOL_HPP
