#ifndef BSETS_PLANE_CANONICALFORMX_HPP
#define BSETS_PLANE_CANONICALFORMX_HPP

// TODO currently only implemented for Q=9. Q=4 is similar, Q=8 must take two images!

#include "CanonicalForm.hpp"
/*
 * Computes the canonical form with respect to the full collineation group
 * and not just the projectivities
 */

template<int Q>
class CanonicalFormX : public CanonicalForm<Q> {

public:
    using CanonicalForm<Q>::V;

    CanonicalFormX(const WeightsBase<V> &base) : CanonicalForm<Q>(base) {

    }

protected:
    virtual void processImage (const PointSet<V> &image);
};

// currently only implemented for 9 - 4 is a copy, 8 needs a second image
template<>
void CanonicalFormX<9>::processImage(const PointSet<V> &image) {
    CanonicalForm<9>::processImage(image);
    PointSet<V> newImage{};
    for (int pt = 0; pt < V; ++pt) {
        if (image.contains(pt)) {
            newImage.add ( Point<9>::get(pt).conj().index() );
        }
    }
    CanonicalForm<9>::processImage(newImage);
}


#endif //BSETS_PLANE_CANONICALFORMX_HPP
