#ifndef BSETS_PLANE_PROJECTIVEPLANE_HPP
#define BSETS_PLANE_PROJECTIVEPLANE_HPP

#include "PointLineGeometry.hpp"
#include "Point.hpp"

////////////////////////////////////////
// DECLARATIONS
////////////////////////////////////////

/**
 * The point line geometry of points and lines of the plane,
 * in its standard coordinate representation
 */
template<int Q>
class ProjectivePlane : public PointLineGeometry<Q * Q + Q + 1, Q * Q + Q + 1> {

private:
    static constexpr int V = Q * Q + Q + 1;

    using PointLineGeometry<V, V>::setIncident;

public:
    ProjectivePlane();
};

template<int Q>
ProjectivePlane<Q>::ProjectivePlane() {

    for (const Point<Q> &pt: Point<Q>::all()) {
        for (const Point<Q> &ln: Point<Q>::all()) {
            if (pt.liesOn(ln)) {
                setIncident(pt.index(),ln.index());
            }
        }
    }
}

////////////////////////////////////////
// DEFINITIONS
////////////////////////////////////////


#endif //BSETS_PLANE_PROJECTIVEPLANE_HPP
