#include <iostream>
#include <iomanip>
#include "PointSet.hpp"
#include "Semi.hpp"

/**
 * Converts standard numbering in projective plane to semi-affine numbering
 */
int main(int , char** ) {

    constexpr int Q = ORDER_OF_FIELD;

    // input from std::cin - output to std::cout
    std::string line;
    while (std::getline(std::cin, line)) {
        std::istringstream iss(line);
        PointSet<Q*Q-1> set{};
        PointSet<Q+1> inftySet{};
        bool hasOrigin{false};
        while (iss.peek() != EOF) {
            char ch;
            int pt;
            iss >> ch >> pt; // ch will always be -
            const std::pair<SemiPointType, int> &pair = Semi<Q>::index(pt);
            if (pair.first == SEMI_AFFINE) {
                set.add(pair.second);
            } else if (pair.first == AT_INFTY) {
                inftySet.add(pair.second);
            } else { // ORIGIN
                hasOrigin = true;
            }
        }
        if (hasOrigin) {
            printf("+0");
        }
        inftySet.print('-');
        set.print(':');
        putchar('\n');
    }
    return 0;
}