#!/bin/bash
#
# common code for scripts in this directory

# Find the top level directory
#
REALPRG=$(readlink -f -n $0)
DIR=$(dirname $REALPRG)
if [[ ! -d $DIR/scripts ]]; then
  DIR=$(dirname $DIR)
  [[ -d $DIR/scripts ]] || { echo >&2 "ERROR *** base directory not found"; exit 1; }
fi
#
cd $DIR || exit
#
fgrep -q "ORDER_OF_FIELD=$1" CMakeLists.txt || \
    { echo >&2 "ERROR *** Program probably not compiled for the correct field"; exit 1; }

# recompile the programs, if necessary
cmake --build cmake-build-release  >/dev/null 2>&1
PROGS=$DIR/cmake-build-release
