#include <iostream>
#include <iomanip>
#include "PointSet.hpp"
#include "Semi.hpp"

/**
 * Converts semi-affine numbering to standard numbering in projective plane
 */
int main(int , char** ) {

    constexpr int Q = ORDER_OF_FIELD;

    // input from std::cin - output to std::cout
    std::string line;
    while (std::getline(std::cin, line)) {
        std::istringstream iss(line);
        PointSet<Q*Q+Q+1> set{};
        while (iss.peek() != EOF) {
            char ch;
            int pt;
            iss >> ch >> pt;
            if (ch == '+') {
                // origin
                set.add(Semi<Q>::origin.index());
            } else if (ch == '-') {
                // infty
                set.add( Semi<Q>::atInfty(pt).index());
            } else { // ch == ':'
                // fat
                set.add(Semi<Q>::point(pt).index());
            }
        }
        set.print('-');
        putchar('\n');
    }
    return 0;
}