#include <iostream>
#include <iomanip>
#include "PointSet.hpp"
#include "Semi.hpp"
#include "ColourablePlane.hpp"
#include "SparseGraph.hpp"  // for toString
#include "singer/Singer.hpp"
#include "singer/SingerGeometry.hpp"

/**
 * Computes and prints the orbits of points and lines for a given set in singer format
 */
int main(int , char** ) {

    constexpr int Q = ORDER_OF_FIELD;
    const int V = Singer<Q>::V;

    const SingerGeometry<Q> geometry{};
    ColourablePlane<V> geom(geometry);

    // input from std::cin - output to std::cout
    std::string line;
    while (std::getline(std::cin, line)) {
        std::istringstream iss(line);
        PointSet<V> set{};
        while (iss.peek() != EOF) {
            char ch;
            int pt;
            iss >> ch >> pt; // ch will always be % TODO: check?
            set.add(pt);
        }
        geom.colour(set);
        printf("%d ", geom.stabilizerSize());
        geom.printOrbits();
        printf("\n");
    }
    return 0;
}