#include <iostream>
#include <iomanip>
#include "PointSet.hpp"
#include "Semi.hpp"
#include "singer/Singer.hpp"

/**
 * Converts Singer cycle numbering to standard numbering
 */
int main(int , char** ) {

    constexpr int Q = ORDER_OF_FIELD;
    constexpr int V = Q*Q+Q+1;

    // input from std::cin - output to std::cout
    std::string line;
    while (std::getline(std::cin, line)) {
        std::istringstream iss(line);
        PointSet<V> set{};
        while (iss.peek() != EOF) {
            char ch;
            int pt;
            iss >> ch >> pt; // ch will always be % TODO: check?
            set.add(Singer<Q>::point(pt).index());
        }
        set.print('-');
        putchar('\n');
    }
    return 0;
}