#ifndef BSETSNONTRIV_THREE_HPP
#define BSETSNONTRIV_THREE_HPP

// Defines the parameters of a geometry with an automorphism of order three working on it in terms of the field order Q

template <int Q>
struct Three {

    // Number of affine 'fat' points, i.e., orbits of size 3
    static constexpr int F = (Q*Q-1)/3;

    // Number of fat points at infinity
    static constexpr int K = (Q+1)/3;

    // Total number of orbits
    static constexpr int V = K+F+1;

};

#endif //BSETSNONTRIV_THREE_HPP
