#include "InvolGeometry.hpp"
#include "ColourablePlane.hpp"
#include "ThreeGeometry.hpp"

static constexpr int Q = ORDER_OF_FIELD;
static constexpr int V = Invol<Q>::V;

/**
* Verifies that the group used by nauty has the expected size
*/
int main(int, char**) {

    ColourablePlane<Invol<Q>::V> involPlane {(InvolGeometry<Q>) {}};
    involPlane.colour(PointSet<Invol<Q>::V>()); // colour with empty set
    printf ("Normalizer involution: expected: %d, found: %d\n", (Q+1)*Q*(Q-1)*(Q-1)/2, involPlane.stabilizerSize());

    if constexpr (Q%3 == 2) {
        ColourablePlane<Three<Q>::V> threePlane {(ThreeGeometry<Q>) {}};
        threePlane.colour(PointSet<Three<Q>::V>()); // colour with empty set
        printf ("Normalizer order 3: expected: %d, found: %d\n", 2*(Q+1)*(Q-1)/3, threePlane.stabilizerSize());
    }

}